.286
  w equ word ptr
  b equ byte ptr
data segment public
  extrn vscreen:dword
  extrn palette:dataptr
data ends

code segment public
assume cs:code,ds:data
public p13_2_modex, setpal, getpal, fade_out

plane_l: db 0
plane_pos: dw 0

p13_2_modex proc pascal far start,pic_size:word
    mov dx,03ceh                ;Write Mode 0 setzen
    mov ax,4005h                ;ber GDC Register 5 (GDC Mode)
    out dx,ax

    mov b plane_l,1             ;Plane-Maske speichern
    push ds
    lds si,dword ptr ds:vscreen ;Quelladresse laden
    mov w plane_pos,si          ;und sichern
    mov ax,0a000h               ;Zieladresse setzen
    mov es,ax
    mov di,start
    mov cx,pic_size             ;Anzahl holen
@lpplane:
    mov al,02h                  ;TS Register 2 (Write Plane Mask)
    mov ah,b plane_l            ;entsprechende Plane maskieren
    mov dx,3c4h
    out dx,ax

  @lp1:
    movsb                       ;Byte kopieren
    add si,3                    ;auf nchstes Quellbyte positionieren
    loop @lp1

    mov di,start                ;Zieladresse neu holen
    inc w plane_pos             ;Quelladresse auf neuen Start
    mov si,w plane_pos
    mov cx,pic_size             ;Gre holen
    shl b plane_l,1             ;nchste Plane maskieren
    cmp b plane_l,10h           ;alle 4 Planes kopiert ?
    jne @lpplane

    pop ds
    ret
Endp

WaitRetrace proc pascal far
  mov dx,3dah                   ;Input Status Register 1
@wait1:
  in al,dx                      ;Bit 3 wird 0 wenn Strahl beim Bildaufbau
  test al,08h
  jnz @wait1
@wait2:
  in al,dx                      ;Bit 3 wird 1 wenn Retrace
  test al,08h
  jz @wait2
  ret                           ;jetzt ist Strahl ganz unten am Bildschirm
Endp

SetPal proc pascal far
  push si
  mov si,offset palette         ;Adresse holen
  mov cx,256*3                  ;Anzahl Farben holen
  xor al,al
  mov dx,03c8h                  ;External Palette RAM, Pixel Write Adress
  out dx,al                     ;ab Farbe 0 setzen
  inc dx                        ;Pixel Color Value

  rep outsb                     ;alle Farben an VGA schicken
  pop si
  ret
Endp

getpal proc pascal far
  push di
  mov di,offset palette         ;Adresse holen
  mov cx,256*3                  ;Anzahl Farben holen
  xor al,al
  mov dx,03c7h                  ;External Palette RAM, Pixel Read Adress
  out dx,al                     ;ab Farbe 0 lesen
  mov dx,3c9h                   ;Pixel Color Value

  rep insb                      ;alle Farben an VGA schicken
  pop di
  ret
Endp

fade_out proc pascal far        ;Fadet Bild raus, Video-Modus unabhngig
local groesste:word             ;beinhaltet maximal mglichen Farb-Wert
  mov groesste,63
  mov ax,ds                     ;Ziel-Segment laden
  mov es,ax
main_loop:                      ;Hauptschleife, wird einmal pro Bild durchl.
  lea si,palette                ;Quell- und Zieloffset auf Palette
  mov di,si
  mov cx,768                    ;768 Byte modifizieren
lp:
  lodsb                         ;Wert holen
  dec al                        ;herunterzhlen
  jns setzen                    ;wenn noch nicht negativ -> setzen
  xor al,al                     ;sonst 0
setzen:
  stosb                         ;Zielwert in "Palette" schreiben

  dec cx                        ;Schleifenzhler
  jne lp

  call waitretrace              ;auf Retrace synchronisieren
  call setpal                   ;berechnete Palette setzen
  dec groesste                  ;uere Schleife herunter zhlen
  jne main_loop                 ;noch nicht fertig ? dann weiter

  ret
fade_out endp

code ends
end
